import random


KEYS = ['FIRST_YEAR', 'SECOND_YEAR', 'THIRD_YEAR', 'FOURTH_YEAR', 
        'LITERATURE', 'SCIENCE', 'MATH', 'SOCIAL_STUDIES', 'ELECTIVES']


def create_app():
    """
    return a random example application using a random number generator. 

    Arguments: N/A

    Returns:
        Dict[str, int]: applications mapping labels to GPAs
    """
    app = {}
    for key in KEYS:
        app[key] = 2 + 2 * random.random()
    return app


def create_apps(num_apps):
    """
    return many random example applications
    the return value is a list of length num_apps, each entry of which is an example application. 

    Arguments:
        num_apps (int): the number of apps to create

    Returns:
        List[Dict[str, int]]: a list of applications
    """
    apps = []
    for i in range(num_apps):
        apps.append(create_app())
    return apps


def print_apps(apps, first_n):
    """
    print a desired number of applications from a list in a slightly more readable format. 

    Arguments:
        apps (List[Dict[str, int]]): a list of applications
        first_n (int): the number of apps to print

    Returns:
        None
    """
    for app in apps[:first_n]:
        for k in KEYS:
            if k == KEYS[-1]:
                print(f"{k} {app[k]:.1f}")
            else:
                print(f"{k} {app[k]:.1f}", end=", ")
